<?php

/*********************************************************************

 メディア一括表示プラグインのdisplayプラグイン (2013/05/19)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

//外部ファイル読み込み
require_once FREO_MAIN_DIR . 'freo/internals/security_media.php';
require_once FREO_MAIN_DIR . 'freo/internals/filter_media.php';

/* メイン処理 */
function freo_display_media_randam()
{
	global $freo;

	$folder_path = $freo->config['plugin']['media_randam']['folder_path'];
	$target_folder = (FREO_FILE_DIR . 'medias/' . $freo->config['plugin']['media_randam']['folder_path']);

	//メディアフィルター取得
	$media_filters = freo_filter_media('user', array($folder_path . '/'));
	$media_filter  = $media_filters[$folder_path . '/'];
	if ($media_filter) {
		freo_error($freo->config['media']['filter_message']);
	}

	//ページ保護データ取得
	$media_securities = freo_security_media('user', array($folder_path . '/'));
	$media_security   = $media_securities[$folder_path . '/'];
	if ($media_security) {
		freo_error($freo->config['media']['restriction_message']);
	}

	//閲覧制限の有無を確認
	$restrict_flag = false;

	$media_filters = freo_filter_media('nobody', array($folder_path . '/'));
	$media_filter  = $media_filters[$folder_path . '/'];
	if ($media_filter) {
		$restrict_flag = true;
	}

	$media_securities = freo_security_media('nobody', array($folder_path . '/'));
	$media_security   = $media_securities[$folder_path . '/'];

	if ($media_security) {
		$restrict_flag = true;
	}

	//表示対象ディレクトリ取得
	if ($folder_path) {
		$directory           = FREO_FILE_DIR . 'medias/' . $folder_path . '/';
		$thumbnail_directory = FREO_FILE_DIR . 'media_thumbnails/' . $folder_path . '/';
		$memo_directory      = FREO_FILE_DIR . 'media_memos/' . $folder_path . '/';
	} else {
		$directory           = FREO_FILE_DIR . 'medias/';
		$thumbnail_directory = FREO_FILE_DIR . 'media_thumbnails/';
		$memo_directory      = FREO_FILE_DIR . 'media_memos/';
	}

	//表示範囲取得
	$count = 0;

	$media_randam_lists = array();

	if ($dir = scandir($directory)) {
		//メディア表示
		foreach ($dir as $data) {
			if (!is_file($directory . $data) or preg_match('/^\./', $data)) {
				continue;
			}
			//サムネイルを取得
			if (is_file($thumbnail_directory . $data)) {
				list($thumbnail_width, $thumbnail_height, $thumbnail_size) = freo_file($thumbnail_directory . $data);
				$thumbnail = array(
					'id'     => $thumbnail_directory . $data,
					'path'   => $thumbnail_directory,
					'name'   => $data,
					'type'   => 'file',
					'width'  => $thumbnail_width,
					'height' => $thumbnail_height,
					'size'   => $thumbnail_size
				);
			} else {
				$thumbnail = array();
			}

			//ファイルの説明を取得
			if (is_file($memo_directory . $data . '.txt')) {
				$memo = file_get_contents($memo_directory . $data . '.txt');
				if ($memo === false) {
					freo_error('ファイル ' . $memo_directory . $data . '.txt' . ' を読み込めません。');
				}
			} else {
				$memo = null;
			}

			//ファイル情報を取得
			list($file_width, $file_height, $file_size) = freo_file($directory . $data);
			$media_randam_lists[$count] = array(
				'id'        => $directory . $data,
				'path'      => $directory,
				'name'      => $data,
				'type'      => 'file',
				'width'     => $file_width,
				'height'    => $file_height,
				'size'      => $file_size,
				'thumbnail' => $thumbnail,
				'memo'      => $memo
			);
			$count++;
		}
		$rand = rand(0, $count-1);
		$media_randams = $media_randam_lists[$rand];
	} else {
		freo_error('メディア格納ディレクトリを開けません。');
	}

	//データ割当
	$freo->smarty->assign(array(
		'token'                  => freo_token('create'),
		'plugin_media_randams'            => $media_randams,
		'plugin_media_randam_restriction' => $restrict_flag
	));

	return;
}

?>
